<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from dependence.texi on 28 April 1999 -->

<TITLE>The DEPENDENCE Library - Overview</TITLE>
<link href="dependence_2.html" rel=Next>
<link href="dependence_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the first, previous, <A HREF="dependence_2.html">next</A>, <A HREF="dependence_3.html">last</A> section, <A HREF="dependence_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC1" HREF="dependence_toc.html#TOC1">Overview</A></H1>

<P>
Data dependence analysis involves analyzing the dynamic memory reference
behavior of array operations so that compilers will only parallelize
loops in the cases where any resultant reordering of memory references
does not change the sequential semantics of the program.  In general,
data dependence analysis is undecidable, and compilers must
conservatively approximate array reference behavior, thus
sequentializing parallel loops.  Traditional data dependence analysis
research has concentrated on the simpler problem of affine memory
disambiguation.  Many algorithms have been developed that conservatively
approximate even this simpler problem.  By using a series of algorithms,
each one guaranteed to be exact for a certain class of input.  Our
compiler, in practice, solves exactly and efficiently the affine memory
disambiguation problem.

</P>
<P><HR><P>
<p>Go to the first, previous, <A HREF="dependence_2.html">next</A>, <A HREF="dependence_3.html">last</A> section, <A HREF="dependence_toc.html">table of contents</A>.
</BODY>
</HTML>
